#coding:utf-8
import math
import turtle
Delta=50
# draw a line from (x1, y1) to (x2, y2)
def drawLine (ttl, x1, y1, x2, y2):
    ttl.penup()
    ttl.goto (x1, y1)
    ttl.pendown()
    ttl.goto (x2, y2)
    ttl.penup()

# write label at location x, y
def labelPoint (ttl, x, y, label):
    ttl.penup()
    ttl.goto (x, y)
    ttl.pendown()
    ttl.write (label)
    ttl.penup()

def drawGridMark (ttl, x, y, isVertical):
    if isVertical :
        drawLine (ttl, x, y + 5, x, y - 5)
    else:
        drawLine (ttl, x - 5, y, x + 5, y)

def labelGridPoint (ttl, x, y, isVertical, text):
    if isVertical:
        labelPoint (ttl, x - Delta//5, y - Delta//5, text)
    else:
        labelPoint (ttl, x + Delta//5, y, text)

def drawGridScaled (ttl):
  # draw the axes
    drawLine (ttl, -400, 0, 400, 0)
    drawLine (ttl, 0, 400, 0, -400)

    # label the x axis
    for x in [i*Delta for i in range(-6,7)]:
        drawGridMark (ttl, x, 0, True)
        labelGridPoint (ttl, x-5, -10, True, (x//Delta, 0))

    # label the y axis
    for y in [i*Delta for i in range(-5,6) if i!=0]:
        drawGridMark (ttl, 0, y, False)
        labelGridPoint (ttl, 0, y-8, False, (0, y//Delta))

def drawFnScaled (ttl, fn, lower, upper, step):
    ttl.penup()
    x = lower
    y = fn (x)
    scaledX = x * Delta
    scaledY = y * Delta
    ttl.goto (scaledX, scaledY)
    ttl.pendown()
    while x < upper:
        x = x + step
        y = fn ( x )
        scaledX, scaledY = x * Delta, y * Delta
        ttl.goto (scaledX, scaledY)
    ttl.penup()

def myFunc (x):
    return (x ** 2/5 - 1)
def F(x) :
    return x*x/5-1
def G(a) :
    return ((5+a*a)/(2*a),0)
def  main():
    # put label on top of page
    turtle.title ('Graphs of Functions')

    # setup screen size
    turtle.setup (1200, 1200, 0, 0)

    # create a turtle object
    ttl = turtle.Turtle()

    # draw the grid
    drawGridScaled (ttl)

    # draw sine finction
    ttl.pencolor ('red')
    ttl.speed(0)
    drawFnScaled (ttl, F,-6, 6, 0.01)

    a=5
    ttl.pencolor('blue')
    ttl.speed(1)
    h=0
    drawLine (ttl, a*Delta, 0, a*Delta, F(a)*Delta)
    for j in range(6):
        s,t=G(a)
        drawLine(ttl,a*Delta, F(a)*Delta,s*Delta,t*Delta)
        a=s
        drawLine(ttl,a*Delta,0,a*Delta,F(a)*Delta)
    # persist drawing
    turtle.done()

if __name__ == "__main__":
    main()
